karo: tx6: improve pad ctrl for SD card interfaces
[karo-tx-uboot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5 #
6 # SPDX-License-Identifier:      GPL-2.0+
7
8 usage()
9 {
10         # if exiting with 0, write to stdout, else write to stderr
11         local ret=${1:-0}
12         [ "${ret}" -eq 1 ] && exec 1>&2
13         cat <<-EOF
14         Usage: MAKEALL [options] [--] [boards-to-build]
15
16         Options:
17           -a ARCH,   --arch ARCH       Build all boards with arch ARCH
18           -c CPU,    --cpu CPU         Build all boards with cpu CPU
19           -v VENDOR, --vendor VENDOR   Build all boards with vendor VENDOR
20           -s SOC,    --soc SOC         Build all boards with soc SOC
21           -b BOARD,  --board BOARD     Build all boards with board name BOARD
22           -l,        --list            List all targets to be built
23           -m,        --maintainers     List all targets and maintainer email
24           -M,        --mails           List all targets and all affilated emails
25           -C,        --check           Enable build checking
26           -n,        --continue        Continue (skip boards already built)
27           -r,        --rebuild-errors  Rebuild any boards that errored
28           -h,        --help            This help output
29
30         Selections by these options are logically ANDed; if the same option
31         is used repeatedly, such selections are ORed.  So "-v FOO -v BAR"
32         will select all configurations where the vendor is either FOO or
33         BAR.  Any additional arguments specified on the command line are
34         always build additionally.  See the boards.cfg file for more info.
35
36         If no boards are specified, then the default is "powerpc".
37
38         Environment variables:
39           BUILD_NCPUS      number of parallel make jobs (default: auto)
40           CROSS_COMPILE    cross-compiler toolchain prefix (default: "")
41           CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42                            architecture "ARCH".  Substitute "ARCH" for any
43                            supported architecture (default: "")
44           MAKEALL_LOGDIR   output all logs to here (default: ./LOG/)
45           BUILD_DIR        output build directory (default: ./)
46           BUILD_NBUILDS    number of parallel targets (default: 1)
47
48         Examples:
49           - build all Power Architecture boards:
50               MAKEALL -a powerpc
51               MAKEALL --arch powerpc
52               MAKEALL powerpc
53           - build all PowerPC boards manufactured by vendor "esd":
54               MAKEALL -a powerpc -v esd
55           - build all PowerPC boards manufactured either by "keymile" or "siemens":
56               MAKEALL -a powerpc -v keymile -v siemens
57           - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58               MAKEALL -c mpc83xx -v freescale 4xx
59         EOF
60         exit ${ret}
61 }
62
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
65
66 # Option processing based on util-linux-2.13/getopt-parse.bash
67
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
71 # getopt.
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73      -n 'MAKEALL' -- "$@"`
74
75 [ $? != 0 ] && usage 1
76
77 # Note the quotes around `$TEMP': they are essential!
78 eval set -- "$TEMP"
79
80 SELECTED=''
81 ONLY_LIST=''
82 PRINT_MAINTS=''
83 MAINTAINERS_ONLY=''
84 CONTINUE=''
85 REBUILD_ERRORS=''
86
87 while true ; do
88         case "$1" in
89         -a|--arch)
90                 # echo "Option ARCH: argument \`$2'"
91                 if [ "$opt_a" ] ; then
92                         opt_a="${opt_a%)} || \$2 == \"$2\")"
93                 else
94                         opt_a="(\$2 == \"$2\")"
95                 fi
96                 SELECTED='y'
97                 shift 2 ;;
98         -c|--cpu)
99                 # echo "Option CPU: argument \`$2'"
100                 if [ "$opt_c" ] ; then
101                         opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
102                 else
103                         opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
104                 fi
105                 SELECTED='y'
106                 shift 2 ;;
107         -s|--soc)
108                 # echo "Option SoC: argument \`$2'"
109                 if [ "$opt_s" ] ; then
110                         opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
111                 else
112                         opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
113                 fi
114                 SELECTED='y'
115                 shift 2 ;;
116         -v|--vendor)
117                 # echo "Option VENDOR: argument \`$2'"
118                 if [ "$opt_v" ] ; then
119                         opt_v="${opt_v%)} || \$5 == \"$2\")"
120                 else
121                         opt_v="(\$5 == \"$2\")"
122                 fi
123                 SELECTED='y'
124                 shift 2 ;;
125         -b|--board)
126                 # echo "Option BOARD: argument \`$2'"
127                 if [ "$opt_b" ] ; then
128                         opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129                 else
130                         # We need to check the 7th field too
131                         # for boards whose 6th field is "-"
132                         opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133                 fi
134                 SELECTED='y'
135                 shift 2 ;;
136         -C|--check)
137                 CHECK='C=1'
138                 shift ;;
139         -n|--continue)
140                 CONTINUE='y'
141                 shift ;;
142         -r|--rebuild-errors)
143                 REBUILD_ERRORS='y'
144                 shift ;;
145         -l|--list)
146                 ONLY_LIST='y'
147                 shift ;;
148         -m|--maintainers)
149                 ONLY_LIST='y'
150                 PRINT_MAINTS='y'
151                 MAINTAINERS_ONLY='y'
152                 shift ;;
153         -M|--mails)
154                 ONLY_LIST='y'
155                 PRINT_MAINTS='y'
156                 shift ;;
157         -h|--help)
158                 usage ;;
159         --)
160                 shift ; break ;;
161         *)
162                 echo "Internal error!" >&2 ; exit 1 ;;
163         esac
164 done
165
166 GNU_MAKE=$(scripts/show-gnu-make) || {
167         echo "GNU Make not found" >&2
168         exit 1
169 }
170
171 # echo "Remaining arguments:"
172 # for arg do echo '--> '"\`$arg'" ; done
173
174 tools/genboardscfg.py || {
175         echo "Failed to generate boards.cfg" >&2
176         exit 1
177 }
178
179 FILTER="\$1 !~ /^#/"
180 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
184 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
185
186 if [ "$SELECTED" ] ; then
187         SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
188
189         # Make sure some boards from boards.cfg are actually found
190         if [ -z "$SELECTED" ] ; then
191                 echo "Error: No boards selected, invalid arguments"
192                 exit 1
193         fi
194 fi
195
196 #########################################################################
197
198 # Print statistics when we exit
199 trap exit 1 2 3 15
200 trap print_stats 0
201
202 # Determine number of CPU cores if no default was set
203 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
204
205 if [ "$BUILD_NCPUS" -gt 1 ]
206 then
207         JOBS="-j $((BUILD_NCPUS + 1))"
208 else
209         JOBS=""
210 fi
211
212 if [ "${MAKEALL_LOGDIR}" ] ; then
213         LOG_DIR=${MAKEALL_LOGDIR}
214 else
215         LOG_DIR="LOG"
216 fi
217
218 : ${BUILD_NBUILDS:=1}
219 BUILD_MANY=0
220
221 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
222         BUILD_MANY=1
223         : ${BUILD_DIR:=./build}
224         mkdir -p "${BUILD_DIR}/ERR"
225         find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
226 fi
227
228 : ${BUILD_DIR:=.}
229
230 OUTPUT_PREFIX="${BUILD_DIR}"
231
232 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
233 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234         find "${LOG_DIR}/" -type f -exec rm -f {} +
235 fi
236
237 LIST=""
238
239 # Keep track of the number of builds and errors
240 ERR_CNT=0
241 ERR_LIST=""
242 WRN_CNT=0
243 WRN_LIST=""
244 TOTAL_CNT=0
245 SKIP_CNT=0
246 CURRENT_CNT=0
247 OLDEST_IDX=1
248 RC=0
249
250 # Helper funcs for parsing boards.cfg
251 targets_by_field()
252 {
253         field=$1
254         regexp=$2
255
256         awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
257                                                                 boards.cfg
258 }
259
260 targets_by_arch() { targets_by_field 2 "$@" ; }
261 targets_by_cpu()  { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262 targets_by_soc()  { targets_by_field 4 "$@" ; }
263
264 #########################################################################
265 ## MPC5xx Systems
266 #########################################################################
267
268 LIST_5xx="$(targets_by_cpu mpc5xx)"
269
270 #########################################################################
271 ## MPC5xxx Systems
272 #########################################################################
273
274 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
275
276 #########################################################################
277 ## MPC512x Systems
278 #########################################################################
279
280 LIST_512x="$(targets_by_cpu mpc512x)"
281
282 #########################################################################
283 ## MPC8xx Systems
284 #########################################################################
285
286 LIST_8xx="$(targets_by_cpu mpc8xx)"
287
288 #########################################################################
289 ## PPC4xx Systems
290 #########################################################################
291
292 LIST_4xx="$(targets_by_cpu ppc4xx)"
293
294 #########################################################################
295 ## MPC8260 Systems (includes 8250, 8255 etc.)
296 #########################################################################
297
298 LIST_8260="$(targets_by_cpu mpc8260)"
299
300 #########################################################################
301 ## MPC83xx Systems (includes 8349, etc.)
302 #########################################################################
303
304 LIST_83xx="$(targets_by_cpu mpc83xx)"
305
306 #########################################################################
307 ## MPC85xx Systems (includes 8540, 8560 etc.)
308 #########################################################################
309
310 LIST_85xx="$(targets_by_cpu mpc85xx)"
311
312 #########################################################################
313 ## MPC86xx Systems
314 #########################################################################
315
316 LIST_86xx="$(targets_by_cpu mpc86xx)"
317
318 #########################################################################
319 ## 74xx/7xx Systems
320 #########################################################################
321
322 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
323
324 #########################################################################
325 ## PowerPC groups
326 #########################################################################
327
328 LIST_TSEC="             \
329         ${LIST_83xx}    \
330         ${LIST_85xx}    \
331         ${LIST_86xx}    \
332 "
333
334 LIST_powerpc="          \
335         ${LIST_5xx}     \
336         ${LIST_512x}    \
337         ${LIST_5xxx}    \
338         ${LIST_8xx}     \
339         ${LIST_824x}    \
340         ${LIST_8260}    \
341         ${LIST_83xx}    \
342         ${LIST_85xx}    \
343         ${LIST_86xx}    \
344         ${LIST_4xx}     \
345         ${LIST_74xx_7xx}\
346 "
347
348 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
349 # still using "ppc" instead of "powerpc"
350 LIST_ppc="              \
351         ${LIST_powerpc} \
352 "
353
354 #########################################################################
355 ## StrongARM Systems
356 #########################################################################
357
358 LIST_SA="$(targets_by_cpu sa1100)"
359
360 #########################################################################
361 ## ARM7 Systems
362 #########################################################################
363
364 LIST_ARM7="$(targets_by_cpu arm720t)"
365
366 #########################################################################
367 ## ARM9 Systems
368 #########################################################################
369
370 LIST_ARM9="$(targets_by_cpu arm920t)    \
371         $(targets_by_cpu arm926ejs)     \
372         $(targets_by_cpu arm946es)      \
373 "
374
375 #########################################################################
376 ## ARM11 Systems
377 #########################################################################
378 LIST_ARM11="$(targets_by_cpu arm1136)   \
379         $(targets_by_cpu arm1176)       \
380 "
381
382 #########################################################################
383 ## ARMV7 Systems
384 #########################################################################
385
386 LIST_ARMV7="$(targets_by_cpu armv7)"
387
388 #########################################################################
389 ## ARMV8 Systems
390 #########################################################################
391
392 LIST_ARMV8="$(targets_by_cpu armv8)"
393
394 #########################################################################
395 ## AT91 Systems
396 #########################################################################
397
398 LIST_at91="$(targets_by_soc at91)"
399
400 #########################################################################
401 ## Xscale Systems
402 #########################################################################
403
404 LIST_pxa="$(targets_by_cpu pxa)"
405
406 #########################################################################
407 ## SPEAr Systems
408 #########################################################################
409
410 LIST_spear="$(targets_by_soc spear)"
411
412 #########################################################################
413 ## ARM groups
414 #########################################################################
415
416 LIST_arm="$(targets_by_arch arm |               \
417         for ARMV8_TARGET in $LIST_ARMV8;        \
418                 do sed "/$ARMV8_TARGET/d";      \
419         done)                                   \
420 "
421
422 #########################################################################
423 ## MIPS Systems         (default = big endian)
424 #########################################################################
425
426 LIST_mips="$(targets_by_arch mips)"
427
428 #########################################################################
429 ## OpenRISC Systems
430 #########################################################################
431
432 LIST_openrisc="$(targets_by_arch openrisc)"
433
434 #########################################################################
435 ## x86 Systems
436 #########################################################################
437
438 LIST_x86="$(targets_by_arch x86)"
439
440 #########################################################################
441 ## Nios-II Systems
442 #########################################################################
443
444 LIST_nios2="$(targets_by_arch nios2)"
445
446 #########################################################################
447 ## MicroBlaze Systems
448 #########################################################################
449
450 LIST_microblaze="$(targets_by_arch microblaze)"
451
452 #########################################################################
453 ## ColdFire Systems
454 #########################################################################
455
456 LIST_m68k="$(targets_by_arch m68k)"
457 LIST_coldfire=${LIST_m68k}
458
459 #########################################################################
460 ## AVR32 Systems
461 #########################################################################
462
463 LIST_avr32="$(targets_by_arch avr32)"
464
465 #########################################################################
466 ## Blackfin Systems
467 #########################################################################
468
469 LIST_blackfin="$(targets_by_arch blackfin)"
470
471 #########################################################################
472 ## SH Systems
473 #########################################################################
474
475 LIST_sh2="$(targets_by_cpu sh2)"
476 LIST_sh3="$(targets_by_cpu sh3)"
477 LIST_sh4="$(targets_by_cpu sh4)"
478
479 LIST_sh="$(targets_by_arch sh)"
480
481 #########################################################################
482 ## SPARC Systems
483 #########################################################################
484
485 LIST_sparc="$(targets_by_arch sparc)"
486
487 #########################################################################
488 ## NDS32 Systems
489 #########################################################################
490
491 LIST_nds32="$(targets_by_arch nds32)"
492
493 #########################################################################
494 ## ARC Systems
495 #########################################################################
496
497 LIST_arc="$(targets_by_arch arc)"
498
499 #-----------------------------------------------------------------------
500
501 get_target_location() {
502         local target=$1
503         local BOARD_NAME=""
504         local CONFIG_NAME=""
505         local board=""
506         local vendor=""
507
508         # Automatic mode
509         local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
510         if [ -z "${line}" ] ; then echo "" ; return ; fi
511
512         set ${line}
513
514         CONFIG_NAME="${7%_defconfig}"
515
516         [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
517
518         if [ $# -gt 5 ]; then
519                 if [ "$6" = "-" ] ; then
520                         board=${BOARD_NAME}
521                 else
522                         board="$6"
523                 fi
524         fi
525
526         [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
527         [ $# -gt 6 ] && [ "$8" != "-" ] && {
528                 tmp="${8%:*}"
529                 if [ "$tmp" ] ; then
530                         CONFIG_NAME="$tmp"
531                 fi
532         }
533
534         # Assign board directory to BOARDIR variable
535         if [ "${vendor}" == "-" ] ; then
536             BOARDDIR=${board}
537         else
538             BOARDDIR=${vendor}/${board}
539         fi
540
541         echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
542 }
543
544 get_target_maintainers() {
545         local name=`echo $1 | cut -d : -f 3`
546
547         local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
548         if [ -z "${line}" ]; then
549                 echo ""
550                 return ;
551         fi
552
553         local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
554         [ "$mails" == "-" ] && mails=""
555         echo "$mails"
556 }
557
558 get_target_arch() {
559         local target=$1
560
561         # Automatic mode
562         local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
563
564         if [ -z "${line}" ] ; then echo "" ; return ; fi
565
566         set ${line}
567         echo "$2"
568 }
569
570 list_target() {
571         if [ "$PRINT_MAINTS" != 'y' ] ; then
572                 echo "$1"
573                 return
574         fi
575
576         echo -n "$1:"
577
578         local loc=`get_target_location $1`
579
580         if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
581
582         local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
583
584         if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
585
586                 local dir=`echo ${loc} | cut -d ":" -f 2`
587                 local cfg=`echo ${loc} | cut -d ":" -f 1`
588                 local git_result=`git log --format=%aE board/${dir} \
589                                 include/configs/${cfg}.h | grep "@"`
590                 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
591                                                 head -n 3`
592                 local git_result_top=`echo ${git_result} | tr " " "\n" | \
593                         sort | uniq -c | sort -nr | head -n 3 | \
594                         sed "s/^ \+[0-9]\+ \+//"`
595
596                 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
597                         sort -u | tr "\n" " " | sed "s/ $//" ;
598         else
599                 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
600                                                 sed "s/ $//" ;
601         fi
602
603         echo ""
604 }
605
606 # Each finished build will have a file called ${donep}${n},
607 # where n is the index of the build. Each build
608 # we've already noted as finished will have ${skipp}${n}.
609 # The code managing the build process will use this information
610 # to ensure that only BUILD_NBUILDS builds are in flight at once
611 donep="${LOG_DIR}/._done_"
612 skipp="${LOG_DIR}/._skip_"
613
614 build_target_killed() {
615         echo "Aborted $target build."
616         # Remove the logs for this board since it was aborted
617         rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
618         exit
619 }
620
621 build_target() {
622         target=$1
623         build_idx=$2
624
625         if [ "$ONLY_LIST" == 'y' ] ; then
626                 list_target ${target}
627                 return
628         fi
629
630         if [ $BUILD_MANY == 1 ] ; then
631                 output_dir="${OUTPUT_PREFIX}/${target}"
632                 mkdir -p "${output_dir}"
633                 trap build_target_killed TERM
634         else
635                 output_dir="${OUTPUT_PREFIX}"
636         fi
637
638         target_arch=$(get_target_arch ${target})
639         eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
640         if [ "${cross_toolchain}" ] ; then
641             MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
642         elif [ "${CROSS_COMPILE}" ] ; then
643             MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
644         else
645             MAKE=$GNU_MAKE
646         fi
647
648         if [  "${output_dir}" != "." ] ; then
649                 MAKE="${MAKE} O=${output_dir}"
650         fi
651
652         ${MAKE} mrproper >/dev/null
653
654         echo "Building ${target} board..."
655         ${MAKE} -s ${target}_defconfig >/dev/null
656
657         ${MAKE} ${JOBS} ${CHECK} all \
658                 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
659
660         # Check for 'make' errors
661         if [ ${PIPESTATUS[0]} -ne 0 ] ; then
662                 RC=1
663         fi
664
665         if [ $BUILD_MANY == 1 ] ; then
666                 trap - TERM
667
668                 ${MAKE} -s clean
669
670                 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
671                         cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
672                 else
673                         rm ${LOG_DIR}/${target}.ERR
674                 fi
675         else
676                 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
677                         if grep -iw error ${LOG_DIR}/${target}.ERR ; then
678                                 : $(( ERR_CNT += 1 ))
679                                 ERR_LIST="${ERR_LIST} $target"
680                         else
681                                 : $(( WRN_CNT += 1 ))
682                                 WRN_LIST="${WRN_LIST} $target"
683                         fi
684                 else
685                         rm ${LOG_DIR}/${target}.ERR
686                 fi
687         fi
688
689         OBJS=${output_dir}/u-boot
690         if [ -e ${output_dir}/spl/u-boot-spl ]; then
691                 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
692         fi
693
694         ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
695
696         [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
697
698         touch "${donep}${build_idx}"
699 }
700
701 manage_builds() {
702         search_idx=${OLDEST_IDX}
703         if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
704
705         while true; do
706                 if [ -e "${donep}${search_idx}" ] ; then
707                         : $(( CURRENT_CNT-- ))
708                         [ ${OLDEST_IDX} -eq ${search_idx} ] &&
709                                 : $(( OLDEST_IDX++ ))
710
711                         # Only want to count it once
712                         rm -f "${donep}${search_idx}"
713                         touch "${skipp}${search_idx}"
714                 elif [ -e "${skipp}${search_idx}" ] ; then
715                         [ ${OLDEST_IDX} -eq ${search_idx} ] &&
716                                 : $(( OLDEST_IDX++ ))
717                 fi
718                 : $(( search_idx++ ))
719                 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
720                         if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
721                                 search_idx=${OLDEST_IDX}
722                                 sleep 1
723                         else
724                                 break
725                         fi
726                 fi
727         done
728 }
729
730 build_targets() {
731         for t in "$@" ; do
732                 # If a LIST_xxx var exists, use it.  But avoid variable
733                 # expansion in the eval when a board name contains certain
734                 # characters that the shell interprets.
735                 case ${t} in
736                         *[-+=]*) list= ;;
737                         *)       list=$(eval echo '${LIST_'$t'}') ;;
738                 esac
739                 if [ -n "${list}" ] ; then
740                         build_targets ${list}
741                 else
742                         : $((TOTAL_CNT += 1))
743                         : $((CURRENT_CNT += 1))
744                         rm -f "${donep}${TOTAL_CNT}"
745                         rm -f "${skipp}${TOTAL_CNT}"
746                         if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
747                                 : $((SKIP_CNT += 1))
748                                 touch "${donep}${TOTAL_CNT}"
749                         elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
750                                 : $((SKIP_CNT += 1))
751                                 touch "${donep}${TOTAL_CNT}"
752                         else
753                                 if [ $BUILD_MANY == 1 ] ; then
754                                         build_target ${t} ${TOTAL_CNT} &
755                                 else
756                                         CUR_TGT="${t}"
757                                         build_target ${t} ${TOTAL_CNT}
758                                         CUR_TGT=''
759                                 fi
760                         fi
761                 fi
762
763                 # We maintain a running count of all the builds we have done.
764                 # Each finished build will have a file called ${donep}${n},
765                 # where n is the index of the build. Each build
766                 # we've already noted as finished will have ${skipp}${n}.
767                 # We track the current index via TOTAL_CNT, and the oldest
768                 # index. When we exceed the maximum number of parallel builds,
769                 # We look from oldest to current for builds that have completed,
770                 # and update the current count and oldest index as appropriate.
771                 # If we've gone through the entire list, wait a second, and
772                 # reprocess the entire list until we find a build that has
773                 # completed
774                 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
775                         manage_builds
776                 fi
777         done
778 }
779
780 #-----------------------------------------------------------------------
781
782 kill_children() {
783         local OS=$(uname -s)
784         local children=""
785         case "${OS}" in
786                 "Darwin")
787                         # Mac OS X is known to have BSD style ps
788                         local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
789                         children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
790                         ;;
791                 *)
792                         # everything else tries the GNU style
793                         local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
794                         children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
795                         ;;
796         esac
797
798         kill $children 2> /dev/null
799         wait $children 2> /dev/null
800
801         exit
802 }
803
804 print_stats() {
805         if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
806
807         # Only count boards that completed
808         : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
809
810         rm -f ${donep}* ${skipp}*
811
812         if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
813                 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
814                 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
815                 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
816                 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
817                 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
818                 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
819         else
820                 # Remove the logs for any board that was interrupted
821                 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
822         fi
823
824         : $((TOTAL_CNT -= ${SKIP_CNT}))
825         echo ""
826         echo "--------------------- SUMMARY ----------------------------"
827         if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
828                 echo "Boards skipped: ${SKIP_CNT}"
829         fi
830         echo "Boards compiled: ${TOTAL_CNT}"
831         if [ ${ERR_CNT} -gt 0 ] ; then
832                 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
833         fi
834         if [ ${WRN_CNT} -gt 0 ] ; then
835                 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
836         fi
837         echo "----------------------------------------------------------"
838
839         if [ $BUILD_MANY == 1 ] ; then
840                 kill_children
841         fi
842
843         exit $RC
844 }
845
846 #-----------------------------------------------------------------------
847
848 # Build target groups selected by options, plus any command line args
849 set -- ${SELECTED} "$@"
850 # run PowerPC by default
851 [ $# = 0 ] && set -- powerpc
852 build_targets "$@"
853 wait